-- update hosting

ALTER TABLE hosting MODIFY webstat ENUM('true', 'false', 'none', 'webalizer', 'awstats') NOT NULL DEFAULT 'none';
UPDATE hosting SET webstat = 'none' WHERE webstat <> 'true';
UPDATE hosting SET webstat = 'webalizer' WHERE webstat = 'true';
ALTER TABLE hosting MODIFY webstat ENUM('none', 'webalizer', 'awstats') NOT NULL DEFAULT 'none';
-- FastCGI suport
ALTER TABLE hosting ADD COLUMN fastcgi	ENUM('false','true') NOT NULL DEFAULT 'false';
ALTER TABLE subdomains ADD COLUMN fastcgi ENUM('false','true') NOT NULL DEFAULT 'false';
ALTER TABLE web_users ADD COLUMN fastcgi ENUM('false','true') NOT NULL DEFAULT 'false';

--- actions

replace into actions(name, descr, enabled) values ('domain_alias_dns_update', 'Update Domain alias DNS Zone', 'true');

--- misc

DELETE FROM misc WHERE param = "admin_isPrefEdit";

-- CHAR -> VARCHAR - mysql5 is buggy on CHAR

ALTER TABLE clients MODIFY pcode VARCHAR(10) CHARACTER SET ascii COLLATE ascii_bin;
ALTER TABLE clients MODIFY country VARCHAR(2) CHARACTER SET ascii COLLATE ascii_bin;
ALTER TABLE hosting MODIFY fp_adm VARCHAR(16) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE hosting MODIFY fp_pass VARCHAR(20) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE pd_users MODIFY login VARCHAR(20) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE smtp_poplocks MODIFY ip_address VARCHAR(15) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE Notifications MODIFY status VARCHAR(1) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE Notifications MODIFY send2admin VARCHAR(1) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE Notifications MODIFY send2client VARCHAR(1) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE Notifications MODIFY send2dlu VARCHAR(1) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE Notifications MODIFY send2email VARCHAR(1) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE sessions MODIFY sess_id VARCHAR(33) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE sessions MODIFY ip_address VARCHAR(15) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE data_bases MODIFY name VARCHAR(63) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE db_users MODIFY login VARCHAR(16) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE Cards MODIFY zip VARCHAR(10) CHARACTER SET ascii COLLATE ascii_bin;
ALTER TABLE Cards MODIFY country VARCHAR(2) CHARACTER SET ascii COLLATE ascii_bin;
ALTER TABLE Permissions MODIFY permission VARCHAR(245) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE Permissions MODIFY value VARCHAR(255) CHARACTER SET binary;
ALTER TABLE Parameters MODIFY parameter VARCHAR(245) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE Parameters MODIFY value VARCHAR(255) CHARACTER SET binary;
ALTER TABLE Limits MODIFY limit_name VARCHAR(245) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE Limits MODIFY value VARCHAR(255) CHARACTER SET binary;
ALTER TABLE Templates MODIFY name VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE TmplData MODIFY element VARCHAR(245) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE TmplData MODIFY value VARCHAR(255) CHARACTER SET binary NOT NULL;
ALTER TABLE Skins MODIFY place VARCHAR(255) CHARACTER SET ascii COLLATE ascii_bin NOT NULL;
ALTER TABLE IP_Addresses MODIFY ip_address VARCHAR(15) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE IP_Addresses MODIFY mask VARCHAR(15) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT '255.255.255.0';
ALTER TABLE log_actions MODIFY ip_address VARCHAR(15) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE cp_access MODIFY netaddr VARCHAR(15) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;
ALTER TABLE cp_access MODIFY netmask VARCHAR(15) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL;

-- mail

ALTER TABLE mail ADD spamfilter ENUM('false','true') NOT NULL DEFAULT 'false' AFTER autoresponder;

-- spamfilter

CREATE TABLE spamfilter (
	id						INT UNSIGNED AUTO_INCREMENT PRIMARY KEY
,	username				VARCHAR(128) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL
,	preferences				ENUM('false','true') NOT NULL DEFAULT 'false'
,	reject_spam				ENUM('false','true') NOT NULL DEFAULT 'false'
,							UNIQUE (username)
) TYPE=InnoDB;

-- spamfilter_preferences

CREATE TABLE spamfilter_preferences (
	prefid					INT UNSIGNED AUTO_INCREMENT PRIMARY KEY
,	spamfilter_id			INT UNSIGNED NOT NULL
,	preference				VARCHAR(30) CHARACTER SET ascii COLLATE ascii_general_ci NOT NULL DEFAULT ''
,	value					VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT ''
,							UNIQUE spamfilter_id (spamfilter_id, preference, value)
) TYPE=InnoDB;

-- spamfilter users

INSERT INTO spamfilter (username, preferences, reject_spam) VALUES ('*@*', 'true', 'false');
INSERT INTO spamfilter (username, preferences, reject_spam) SELECT CONCAT(m.mail_name, '@', d.name), 'true', IF(c.spam_action = 'delete', 'true', 'false') FROM mail m INNER JOIN domains d ON m.dom_id = d.id LEFT JOIN sa_conf c ON CONCAT(m.mail_name, '@', d.name) = c.mailname;

-- spamfilter required_score

INSERT INTO spamfilter_preferences (spamfilter_id, preference, value) SELECT sf.id, 'required_score', IFNULL(c.hits_required, '7.00') FROM spamfilter sf LEFT JOIN sa_conf c ON sf.username = '*@*' AND c.mailname = '' OR sf.username = c.mailname;

-- spamfilter rewrite_header subject

INSERT INTO spamfilter_preferences (spamfilter_id, preference, value) SELECT sf.id, 'rewrite_header', CONCAT('subject ', IFNULL(c.rw_subject_tag, '*****SPAM*****')) FROM spamfilter sf LEFT JOIN sa_conf c ON sf.username = '*@*' AND c.mailname = '' OR sf.username = c.mailname;

-- spamfilter unblack/unwhite lists

INSERT INTO spamfilter_preferences (spamfilter_id, preference, value) SELECT sf.id, CONCAT('un', sl.color, 'list_from'), ul.pattern FROM spamfilter sf, sa_list ul, sa_list sl WHERE sf.username = ul.mailname AND ul.pattern = sl.pattern AND ul.color IS NULL AND sl.color IN ('black', 'white') AND sl.mailname = '';

-- spamfilter black/white lists

INSERT INTO spamfilter_preferences (spamfilter_id, preference, value) SELECT sf.id, CONCAT(l.color, 'list_from'), l.pattern FROM spamfilter sf, sa_list l WHERE l.color IN ('black', 'white') AND (sf.username = '*@*' AND l.mailname = '' OR sf.username = l.mailname);

-- misc spamfilter params

REPLACE INTO misc (param, val) SELECT 'spamfilter_enabled', IF(flt_enabled IN ('user', 'serv', 'both'), 'true', 'false') FROM sa_conf WHERE mailname = '';
REPLACE INTO misc (param, val) SELECT 'spamfilter_use_mailuser_prefs', IF(flt_enabled IN ('user', 'both'), 'true', 'false') FROM sa_conf WHERE mailname = '';
REPLACE INTO misc (param, val) VALUES ('spamfilter_max_children', 5);

-- spamfilter management permissions

INSERT Permissions (id, permission, value) SELECT perm_id, 'manage_spamfilter', 'true' FROM clients;
INSERT Permissions (id, permission, value) SELECT perm_id, 'manage_spamfilter', 'true' FROM dom_level_usrs;
INSERT Permissions (id, permission, value) SELECT perm_id, 'manage_spamfilter', 'true' FROM mail;

-- convert obsolete spamfilter ignore lists to spamfilter permissions

REPLACE Permissions (id, permission, value) SELECT m.perm_id, 'manage_spamfilter', 'false' FROM mail m, domains d, sa_list l WHERE m.dom_id = d.id AND l.mailname = '' AND l.color = 'gray' AND LOWER(CONCAT(m.mail_name, '@', d.name)) LIKE BINARY(LOWER(REPLACE(REPLACE(l.pattern, '*', '%'), '?', '_')));

-- Dr.Web management permissions

INSERT Permissions (id, permission, value) SELECT perm_id, 'manage_drweb', 'true' FROM mail;

-- max_domain_aliases initialisation

INSERT INTO Limits(id, limit_name, value) SELECT limits_id, 'max_doman_alises', -1 FROM clients;
INSERT INTO Limits(id, limit_name, value) SELECT limits_id, 'max_doman_alises', -1 FROM domains;

-- whats new
INSERT INTO NewsArticles(class) VALUES ('WhatsNew8_1');

--domainaliases

ALTER TABLE domainaliases ADD tomcat ENUM('false', 'true') NOT NULL DEFAULT 'false';

---- Maiss Mail section 
CREATE TABLE mass_mail ( 
	id						INT UNSIGNED AUTO_INCREMENT PRIMARY KEY 
								-- mass mail ID 
,	name					VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' 
								-- mass mail NAME 
,	from_email				VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT '' 
								-- mass mail FROM 
,	to_admin				ENUM('false', 'true') NOT NULL DEFAULT 'false' 
								-- mass mail TO ADMIN 
,	to_clients				ENUM('false', 'true') NOT NULL DEFAULT 'false' 
								-- mass mail TO CLIENTS 
,	to_clients_mode			ENUM('all', 'select', 'except') NOT NULL DEFAULT 'all' 
								-- mass mail TO CLIENTS MODE 
,	to_domains				ENUM('false', 'true') NOT NULL DEFAULT 'false' 
								-- mass mail TO DOMAINS 
,	to_domains_mode			ENUM('all', 'select', 'except') NOT NULL DEFAULT 'all' 
								-- mass mail TO DOMAINS MODE 
,	subject					VARCHAR(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL 
								-- mass mail SUBJECT 
,	body					TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL 
								-- mass mail BODY 
,	cdate					DATE 
								-- mass mail creation date 
,							UNIQUE(name) 
) TYPE=InnoDB; 
 
CREATE TABLE mass_mail_clients ( 
	mm_id					INT UNSIGNED NOT NULL 
								-- mass mail ID 
,	cl_id					INT UNSIGNED NOT NULL 
								-- client ID 
,							INDEX (mm_id) 
								-- REFERENCES mass_mail (id) 
,							INDEX (cl_id) 
								-- REFERENCES clients (id) 
,							UNIQUE(mm_id, cl_id) 
) TYPE=InnoDB; 
 
CREATE TABLE mass_mail_domains ( 
	mm_id					INT UNSIGNED NOT NULL 
								-- mass mail ID 
,	dom_id					INT UNSIGNED NOT NULL 
								-- domain ID 
,							INDEX (mm_id) 
								-- REFERENCES mass_mail (id) 
,							INDEX (dom_id) 
								-- REFERENCES domains (id) 
,							UNIQUE(mm_id, dom_id) 
) TYPE=InnoDB; 
